package elec;

/**
 * Represents a switch that has two input wires and one output wire
 * When the switch is UP, the wireUp is connected to the output wire.
 * When the switch is DOWN, the wireDown is connected to the output wire.
 */
public class BetterTwo2OneSwitch implements ITwoWaySwitch, IWire{
  /**
   * The UP input wire
   */
  private IWire _wireUp;
  /**
   * The DOWN input wire
   */
  private IWire _wireDown;
  
  // STUDENT TO ADD NESTED AND/OR INNER/ANONYMOUS CLASSES
  // TO IMPLEMENT STATE DESIGN PATTERN

  
  
  
  /**
   * The current state of switch
   * STUDENT TO COMPLETE INITIALIZATION OF STATE
   */
  private ATwo2OneSwitchState _state = null;
  
  /**
   * Constructor for the class
   * @param wireUp  The wire that is connected when the switch is UP.
   * @param wireDown The wire that is connecte when the switch is DOWN.
   */
  public BetterTwo2OneSwitch(IWire wireUp, IWire wireDown) {
    _wireUp = wireUp;
    _wireDown = wireDown;
  }
  
  /**
   * Set the switch to UP
   */
  public void setUp() {
    // STUDENT TO COMPLETE
    _state = null;
  }
  
  /**
   * Set the switch to DOWN
   */
  public void setDown() {
    // STUDENT TO COMPLETE
    _state = null;
  }
  
  /**
   * Get the voltage on the output wire
   */
  public int getVoltage() {
    return _state.getVoltage();
  }
}


